######################################################################
# This file contains a few bits of demonstration code for the
# accompanying file oo.tcl; you may use this file for any purpose
# you want.
#

package require oo

Class define Example {
    inherit Object
    constructor {string} {
	puts "Constructed object ($this): $string"
	$this set initMsg $string
    }
    destructor {
	puts "Deleting object ($this): $initMsg"
    }
    method print {{channel stdout}} {
	puts $channel "This is $initMsg"
    }
}

set o1 [Example new foo]
set o2 [Example new bar]
$o1 delete
$o2 delete

# Change from List to UniqueList to see how behaviour is easily
# modified by subclassing

set l [List new]
$l add [Example new "Demo #1"]
$l add [Example new "Demo #2"]
$l add [Example new "Demo #3"]
# Alternative that shows off that $l holds references:
#   set obj [$l index 0]
#   rename $obj evil
#   $l add evil
$l add [$l index 0]
puts "Have [$l length] items in list"
set ctr 0
$l iterate v {
    puts "Item [incr ctr]: $v"
    if {[$v isa Object]} {
	puts "(an object)"
    }
}
$l delete
